import React from "react";
import { useFuse } from "./hooks/useFuse";
import { FuzzyInputProvider } from "./hooks/useFuzzyInput";
import { FuzzyResultProvider } from "./hooks/useFuzzyResult";
import FuzzyGui from "./FuzzyGui";
// fuse specific default option
var optionsDefault = {
    //includeMatches: true,
    ignoreLocation: true,
    ignoreFieldNorm: false,
    includeScore: true,
    keys: ["txt"],
};
//default options for mark.js
var markOptionsDefault = {
    element: "b",
    accuracy: "complementary",
    exclude: ["h5"],
};
var ZIMFuzzySearch = function (_a) {
    var data = _a.data, tagConceptMap = _a.tagConceptMap, onSelect = _a.onSelect, searchInput = _a.searchInput, _b = _a.placeHolder, placeHolder = _b === void 0 ? "Search..." : _b, setSearchInput = _a.setSearchInput, _c = _a.fuseOptions, fuseOptions = _c === void 0 ? optionsDefault : _c, _d = _a.markOptions, markOptions = _d === void 0 ? markOptionsDefault : _d, _e = _a.resultCountLabel, resultCountLabel = _e === void 0 ? "Matches: " : _e, children = _a.children;
    var _f = useFuse(fuseOptions, data), fuseResult = _f.fuseResult, doFuseSearch = _f.doFuseSearch, groupBy = _f.groupBy;
    var _g = React.useState(searchInput ? searchInput : ""), inputVal = _g[0], setInputVal = _g[1];
    // two way binding
    React.useEffect(function () {
        if (!searchInput)
            return;
        setInputVal(searchInput);
    }, [searchInput]);
    // when input change do search
    React.useEffect(function () {
        doFuseSearch(inputVal);
    }, [inputVal]);
    var handleInput = function (val) {
        setInputVal(val);
        // ensure two way binding
        if (setSearchInput)
            setSearchInput(val);
    };
    return (React.createElement(FuzzyInputProvider, { handleInput: handleInput, inputVal: inputVal, placeHolder: placeHolder, data: data },
        React.createElement(FuzzyResultProvider, { fuzzyResult: fuseResult && Object.keys(fuseResult).length !== 0 ? fuseResult : null, onSelect: onSelect, resultCountLabel: resultCountLabel, tagConceptMap: tagConceptMap }, children ? children : React.createElement(FuzzyGui, { markOptions: markOptions }))));
};
export default ZIMFuzzySearch;
